from xml.dom import minidom, Node
import logging;
import random
import os 

class User:
  def __init__(self, x, y, insultengine):
    self.x = x;
    self.y = y;
    self.dir = 0;
    self.insultengine = insultengine;
    self.insults = [];
    self.comebacks = [];
    self.add_insult(insultengine.get_random_insult());
    self.add_insult(insultengine.get_random_insult());
    self.add_comeback(insultengine.get_random_comeback());
    self.add_comeback(insultengine.get_random_comeback());
    self.add_comeback(insultengine.get_random_comeback());
    self.add_comeback(insultengine.get_random_comeback());

  def add_insult(self, insult):
    if (self.insults.count(insult) == 0):
      self.insults.append(insult);

  def add_comeback(self, comeback):
    if (self.comebacks.count(comeback) == 0):
      self.comebacks.append(comeback);

  def attack(self, enemy, insult, comeback):
    return self.insultengine.insult_result(self, enemy, insult, comeback);

class InsultEngine:
  def __init__(self):
    self.insult_store = {};
    document = minidom.parse(os.path.join('data', 'insults.xml'));
    for node in document.documentElement.getElementsByTagName('text'):
      insult = str(node.getAttribute('insult'));
      comeback = str(node.getAttribute('comeback'));
      self.insult_store.update({insult:comeback});


  def get_comeback_from_insult(self, insult):
    return self.insult_store[insult];


  def get_insult_from_comeback(self, comeback):
    for key in self.insult_store.keys():
      if self.insult_store[key] == comeback:
        return key;

  def get_insults(self):
    return self.insult_store.keys();

  def get_comebacks(self):
    return self.insult_store.values();

  def get_insult_comeback_list(self):
    return self.insult_store.items(); 

  def get_random_insult(self):
    return random.choice(self.insult_store.keys());

  def get_random_comeback(self):
    return random.choice(self.insult_store.values());


  # Do insult exchange, and let users "learn" insults and comebacks from the exchange.
  def insult_result(self, user_insulter, user_replayer, insult, comeback):
    user_replayer.add_insult(insult);
    user_insulter.add_comeback(comeback);
    if comeback == self.get_comeback_from_insult(insult):
      logging.info("Comebacker wins");
      return 1; # comebacker wins
    else:
      logging.info("Insulter wins");
      return 0; # insulter wins

