import Image
import ImageDraw
import ImageFont
import JpegImagePlugin
import PngImagePlugin
import BmpImagePlugin
import GifImagePlugin 
import TgaImagePlugin
import httplib;

import math, sys, os
import pygame.mixer, pygame.time
from isometric import *
from hotisometric import *

from pygame.locals import *
import pygame
import log, logging

from pgu import gui

def load(image_file_name):
  try:
    image = Image.open(image_file_name);
    return pygame.image.fromstring(image.tostring(), image.size, image.mode);

  except IOError:
    pygame.quit();

#****************************************************************************
#
#****************************************************************************
class MainWindow:
  def __init__(self):
    pygame.init();
    self.clock = pygame.time.Clock();
    self.screen_size = (1024, 768);
    self.sky_x = 0;
    self.sky_y = 0;
    self.sky_h = 768;
    self.sky_w = 1024;
    self.angle = 0.1;
    self.radius = 50;
    self.text_y = 0;
    self.time = 0;
    self.screen = pygame.display.set_mode(self.screen_size, pygame.FULLSCREEN);
    pygame.display.set_caption("Boiler Suit: Venting Anger");
    mode = 1
    #logLevel = logging.INFO
    #log.setUpLogging(logLevel);
    mixer = pygame.mixer;
    mixer.init(11025) 
    mixer.music.load(os.path.join('data', 'music1.ogg'));
    #music is looping.
    mixer.music.play(-1);

    while mode == 1:
      self.clock.tick(55);
      self.move_sky();
      self.handle_events();
      surface = self.create_image();
      self.screen.blit(surface, (0,0));
      pygame.display.flip();
      self.time += 1;
      if self.time == 90:  
          self.mainmenu();
          mode == 2
    while mode == 2:
        surface = self.create_image();
        self.screen.blit(surface, (0,0));
        self.mainmenu();

#****************************************************************************
#
#****************************************************************************
  def move_sky(self):
    self.angle += 0.07;
    self.sky_x = int(100 + self.radius * math.cos(self.angle));
    self.sky_y = int(80 + self.radius * math.sin(self.angle));
    self.text_y -= 4;

  def mainmenu(self):
    app = gui.App(background=pygame.transform.scale(pygame.image.load(os.path.join('data', 'background1.jpg')), (1024, 768)));
    app.connect(gui.QUIT, sys.exit, None);
    container = gui.Container(align=-1, valign=-1);
    menu_table = gui.Table(width=200,height=220);
    play_button = gui.Button(("Single Player Game"));
    play_button.connect(gui.CLICK, self.start_game, None);
    hotseat_button = gui.Button(("Hotseat Game"));
    hotseat_button.connect(gui.CLICK, self.hotseat_game, None);

    setting_button = gui.Button(("Help"));
    setting_button.connect(gui.CLICK, self.help, None);
    highscore_button = gui.Button(("Highscores"));
    highscore_button.connect(gui.CLICK, self.highscores, None);

    exit_button = gui.Button(("Exit"));
    exit_button.connect(gui.CLICK, self.quit, None);
    menu_table.add(play_button, 0, 0);
    menu_table.add(gui.Widget(height=15), 0, 1);
    menu_table.add(hotseat_button, 0, 2);
    menu_table.add(gui.Widget(height=15), 0, 3);
    menu_table.add(highscore_button, 0, 4);
    menu_table.add(gui.Widget(height=15), 0, 5);
    menu_table.add(setting_button, 0, 6);
    menu_table.add(gui.Widget(height=15), 0, 7);
    menu_table.add(exit_button, 0, 8);

    container.add(menu_table, 400, 250);
    app.run(container);
    

#****************************************************************************
#
#****************************************************************************
  def help(self, blah):

    self.app = gui.App(background=self.create_rules());
    self.app.connect(gui.QUIT, sys.exit, None);
    container = gui.Container(align=-1, valign=-1);

    exit_button = gui.Button(("Start game"), height = 30, width=100);
    exit_button.connect(gui.CLICK, self.start_game, None);

    container.add(exit_button, 450, 700);
    self.app.run(container);

#****************************************************************************
#
#****************************************************************************
  def highscores(self, blah):
    self.app = gui.App(background=self.create_image2());
    self.app.connect(gui.QUIT, sys.exit, None);
    container = gui.Container(align=-1, valign=-1);
    self.message_label = gui.Label("Highscores for Boiler Suit: Venting Anger in PyWeek2!");
    container.add(self.message_label, 200, 100);

    try:
      conn = httplib.HTTPConnection("www.openrts.org")
      str = "/pyweek/pyweek-scores.txt";
      conn.request("GET", str);
      r1 = conn.getresponse();
      data1 = r1.read();
      logging.info(data1);
      conn.close();
    except:
      logging.info("OOOpps!");
    scores = {};
    for line in data1.splitlines():
      try:
          player = line.split(";");
          name = player[0];  
          score = int(player[1]);  
          scores.update({name:score});
      except:
        continue;

    self.message_view = gui.List(width=500,
                                 height = 500);
    container.add(self.message_view, 250, 200);        

    start_button = gui.Button(("Start game"), height = 30, width=100);
    start_button.connect(gui.CLICK, self.start_game, None);
    exit_button = gui.Button(("Quit"), height = 30, width=100);
    exit_button.connect(gui.CLICK, self.quit, None);


    tscores = scores.values();
    tscores.sort();

    ascores = [];
    for score in tscores:
      ascores.insert(0, score);

    for score in ascores:
      name = self.get_name(score, scores);
      self.message_view.add("%r : %s " % (score, name ), value=0);
    self.message_view.resize();
    self.message_view.repaint();



    container.add(start_button, 400, 740);
    container.add(exit_button, 550, 740);
    self.app.run(container);

#****************************************************************************
#
#****************************************************************************
  def get_name(self, score, list):
    for name in list.keys():
      tscore = list[name];
      if score == tscore:
        del list[name]; 
        return name;
      



#****************************************************************************
#
#****************************************************************************
  def quit(self, blah):
    sys.exit(0);

#****************************************************************************
#
#****************************************************************************
  def create_image(self):
    orig = Image.open(os.path.join('data', 'background1.jpg'));
    image = orig.crop((self.sky_x, self.sky_y,
                          self.sky_x + self.sky_w, self.sky_y + self.sky_h));
    font = ImageFont.truetype("Vera.ttf", 16);
    draw = ImageDraw.Draw(image);
    input = open(os.path.join('data', 'story.txt'), 'r');
    y = 0;
    for line in input:
      draw.text((250, 500 + y + self.text_y), line.rstrip(), font=font, fill=(255, 230, 0)); 
      y += 30;
    del draw; 
    surface = pygame.image.fromstring(image.tostring(), image.size, image.mode);
    return surface;

#****************************************************************************
#
#****************************************************************************
  def create_image2(self):
    orig = Image.open(os.path.join('data', 'background1.jpg'));
    image = orig.crop((self.sky_x, self.sky_y,
                          self.sky_x + self.sky_w, self.sky_y + self.sky_h));
    font = ImageFont.truetype("Vera.ttf", 16);
    draw = ImageDraw.Draw(image);
    input = open(os.path.join('data', 'story.txt'), 'r');
    surface = pygame.image.fromstring(image.tostring(), image.size, image.mode);
    return surface;

#****************************************************************************
#
#****************************************************************************
  def create_rules(self):
    orig = Image.open(os.path.join('data', 'background1.jpg'));
    image = orig.crop((self.sky_x, self.sky_y,
                          self.sky_x + self.sky_w, self.sky_y + self.sky_h));
    font = ImageFont.truetype("Vera.ttf", 16);
    draw = ImageDraw.Draw(image);
    input = open(os.path.join('data', 'rules.txt'), 'r');
    y = 0;
    for line in input:
      draw.text((250, 100 + y ), line.rstrip(), font=font, fill=(255, 230, 0)); 
      y += 30;
    del draw; 
    surface = pygame.image.fromstring(image.tostring(), image.size, image.mode);
    return surface;


#****************************************************************************
#
#****************************************************************************
  def handle_events(self):
   for event in pygame.event.get():
      if event.type == QUIT:
        sys.exit(0);
      elif event.type == KEYDOWN and event.key == K_ESCAPE:
        self.mainmenu();
      elif event.type == KEYDOWN and event.key == K_f:
        print(self.clock.get_fps());
#****************************************************************************
#
#****************************************************************************
  def start_game(self, dumb):
    self.screen.fill((0,0,0));
    IsoScreen(self.screen);
    sys.exit(0);

#****************************************************************************
#
#****************************************************************************
  def hotseat_game(self, dumb):
    self.screen.fill((0,0,0));
    HotIsoScreen(self.screen);
    sys.exit(0);





