import pygame
from pygame.locals import *
from pgu import isovid
import sys, os
import logging;
from random import *
import pygame.mixer, pygame.time

from insultengine import *
from insultengine import *



#****************************************************************************
#
#****************************************************************************
class Map:
  def __init__(self, view):
    self.movemap = {};
    self.moves = 4;
    self.game_over = 0;
    self.turn = 0;
    self.score = 0;
    self.enemies = 8;
    self.insults = InsultEngine();
    self.player_coal = 0;
    self.player_water = 0;
    self.view = view;
    self.player_pos = (25,25);
    self.player_state = "vent";
    self.player_offset = (0, 0);
    self.old_player_pos = (25,25);
    self.user = User(25,25, self.insults);
    self.enemy_list = [];
    self.enemy_list.append(User(20,20, self.insults));
    self.enemy_list.append(User(25,15, self.insults));
    self.enemy_list.append(User(29,24, self.insults));
    self.enemy_list.append(User(5,56, self.insults));
    self.enemy_list.append(User(35,55, self.insults));
    self.enemy_list.append(User(59,33, self.insults));
    self.enemy_list.append(User(60,17, self.insults));
    self.enemy_list.append(User(40,39, self.insults));
    self.coal_list = [];
    self.coal_list.append((8,22));
    self.coal_list.append((61,47));
    self.coal_list.append((59,6));
    self.water_list = [];
    self.water_list.append((28,43));
    self.water_list.append((47,52));
    self.water_list.append((65,37));

    mixer = pygame.mixer;
    mixer.init(11025) 
    mixer.music.load(os.path.join('data', 'music1.ogg'));
    #music is looping.
    mixer.music.play(-1);

    map_surface = pygame.image.load(os.path.join('data', 'movemap.png'));
    for x in range(map_surface.get_width()):
      for y in range(map_surface.get_height()):
        color = map_surface.get_at((x,y));
        if color == (0,0,0,255):
          self.movemap.update({(x,y):1});
        else:
          self.movemap.update({(x,y):0});
#****************************************************************************
#
#****************************************************************************
  def can_goto(self, map_pos):
    try:
      return self.movemap[map_pos];
    except:
      return 0;

#****************************************************************************
#
#****************************************************************************
  def move_player_to(self, map_pos):
    self.check_win();
    old_pos = self.player_pos;
    if self.can_goto(map_pos):
      if self.moves == 0:
        self.view.set_status_text("Not enough time units to move. Press Enter to end your turn.");
      elif ((self.is_coal_at_pos(map_pos) or self.is_water_at_pos(map_pos)) and self.moves <= 1):
        self.view.set_status_text("Not enough time units to move and pick up water or coal. Press Enter to end your turn.");
      else: 
        self.view.set_status_text("Player moved.");
  
        #play sound
        file = os.path.join('data', 'move.ogg');
        sound = pygame.mixer.Sound(file);
        channel = sound.play();

      # Enemy at tile, attack him/her
        if self.is_enemy_at_pos(map_pos):
          self.view.set_status_text("Attacking enemy");
 
          if self.player_coal > 0 and self.player_water > 0:
            self.coal_list.append(map_pos);
          else:
            self.view.set_status_text("You need at least one coal and one water item to attack an enemy.");
            self.old_player_pos = self.player_pos;
            self.player_pos = old_pos;
            return;

          #Attacking state.
          self.player_state = "cannon";

          #play sound
          file = os.path.join('data', 'attack.ogg');
          sound = pygame.mixer.Sound(file);
          channel = sound.play();
          pygame.mixer.music.load(os.path.join('data', 'music-attack.ogg'));
          #music is looping.
          pygame.mixer.music.play(-1);

          enemy = self.get_enemy_at_pos(map_pos);
          self.view.combat_attack(self.user, enemy);
          self.moves -= 1;
          return; 

        x, y = self.view.view.tile_to_view(map_pos);
        self.view.view.view.x, self.view.view.view.y = x - (1024/2), y - (768/2);

        self.old_player_pos = self.player_pos;
        self.player_pos = map_pos;
        x, y = map_pos;
        self.player_state = "walk";
        x_old, y_old = self.old_player_pos;
        if x_old + 1 == x and y_old == y: dir = 7;
        if x_old - 1 == x and y_old == y: dir = 3;
        if x_old - 1 == x and y_old - 1 == y: dir = 2;
        if x_old + 1 == x and y_old + 1 == y: dir = 6;
        if x_old + 1 == x and y_old - 1 == y: dir = 0;
        if x_old == x and y_old + 1 == y: dir = 5;
        if x_old  == x and y_old - 1  == y: dir = 1;
        if x_old - 1 == x and y_old + 1  == y: dir = 4;

        if dir == 0:
          self.player_offset = (-self.view.TW/2, 0); 

        if dir == 4:
          self.player_offset = (self.view.TW/2, 0); 

        if dir == 1:
          self.player_offset = (-self.view.TW/2, self.view.TH/4); 

        if dir == 5:
          self.player_offset = (self.view.TW/2, -self.view.TH/4); 

        if dir == 2:
          self.player_offset = (0, self.view.TH/4); 

        if dir == 6:
          self.player_offset = (0, - self.view.TH/4); 

        if dir == 3:
          self.player_offset = (self.view.TW/2, self.view.TH/4); 

        if dir == 7:
          self.player_offset = (-self.view.TW/2, - self.view.TH/4); 


 

        #Pick up coal/water.
        if self.is_coal_at_pos((x, y)):
          self.view.set_status_text("Picked up coal.");
          self.coal_list.remove((x,y));
          self.player_coal += 1;
          self.moves -= 1;
          self.score += 1;
          self.player_state = "collect";
          self.view.animate();
          self.player_state = "vent";
        if self.is_water_at_pos((x, y)):
          self.view.set_status_text("Picked up water");
          self.water_list.remove((x,y));
          self.player_water += 1;
          self.moves -= 1;
          self.score += 1;
          self.player_state = "collect";
          self.view.animate();
          self.player_state = "vent";
        self.moves -= 1;
        self.view.animate();
        self.player_state = "vent";

    else:
      self.view.set_status_text("Invalid goto destination");

#****************************************************************************
#
#****************************************************************************
  def end_turn(self):
    if not self.check_win():
      if self.game_over == 0:
        self.moves = 4; 
        self.turn += 1;
        self.move_enemies();
        self.view.set_status_text("New turn started. ");

#****************************************************************************
#
#****************************************************************************
  def move_enemies(self):
    for enemy in self.enemy_list:
      x1, y1 = enemy.x, enemy.y;
      x2, y2 = enemy.x, enemy.y;
      xp, yp = self.player_pos;
      if x1 > xp:
        x2 = x1 - 1;
      if x1 < xp:
        x2 = x1 + 1;
      if y1 > yp:
        y2 = y1 - 1;
      if y1 < yp:
        y2 = y1 + 1;   
      if x1 == x2 and y1 == y2: enemy.dir = 5;
      if x1 + 1 == x2 and y1 == y2: enemy.dir = 7;
      if x1 - 1 == x2 and y1 == y2: enemy.dir = 3;
      if x1 - 1 == x2 and y1 - 1 == y2: enemy.dir = 2;
      if x1 + 1 == x2 and y1 + 1 == y2: enemy.dir = 6;
      if x1 + 1 == x2 and y1 - 1 == y2: enemy.dir = 0;
      if x1 == x2 and y1 - 1 == y2: enemy.dir = 5;
      if x1  == x2 and y1 - 1  == y2: enemy.dir = 1;
      if x1 - 1 == x2 and y1 + 1  == y2: enemy.dir = 4;
 
      if xp == x2 and yp == y2:
        self.view.set_status_text("Enemy attacking you.");
        self.player_state = "cannon";
        #play sound
        file = os.path.join('data', 'attack.ogg');
        sound = pygame.mixer.Sound(file);
        channel = sound.play();
        pygame.mixer.music.load(os.path.join('data', 'music-attack.ogg'));
        #music is looping.
        pygame.mixer.music.play(-1);


        self.view.combat_defend(enemy, self.user);
        return;

      if self.is_water_at_pos((x2, y2)) and not self.is_enemy_at_pos((x2,y2)):
        if not self.enemies == 10:
            self.enemies += 1;
            self.enemy_list.append(User(x1, y2, self.insults));   
            self.view.set_status_text("Enemy walked on water, and was cloned.");
            print "enemy cloned"
        else: print "you goof!There are already to many enemies!"
      if self.can_goto((x2, y2)) and not self.is_enemy_at_pos((x2,y2)):
        enemy.x, enemy.y = x2,  y2;  # enemy moved
        myrnd = randint(0, 20);
        if myrnd == 15 and not self.is_water_at_pos((x2, y2)):
          self.water_list.append((x2, y2));
        elif myrnd == 16 and not self.is_coal_at_pos((x2, y2)):
          self.coal_list.append((x2, y2));
#****************************************************************************
#
#****************************************************************************
  def is_enemy_at_pos(self, pos):
    x2, y2 = pos;
    for enemy in self.enemy_list:
      if enemy.x == x2 and enemy.y == y2:
        return 1;

    return 0;

#****************************************************************************
#
#****************************************************************************
  def get_enemy_at_pos(self, pos):
    x2, y2 = pos;
    for enemy in self.enemy_list:
      if enemy.x == x2 and enemy.y == y2:
        return enemy;
    return 0;

#****************************************************************************
#
#****************************************************************************
  def is_water_at_pos(self, pos):
    x2, y2 = pos;
    for (x1, y1) in self.water_list:
      if x1 == x2 and y1 == y2:
        return 1;
    return 0;

#****************************************************************************
#
#****************************************************************************
  def is_coal_at_pos(self, pos):
    x2, y2 = pos;
    for (x1, y1) in self.coal_list:
      if x1 == x2 and y1 == y2:
        return 1;
    return 0;

#****************************************************************************
#
#****************************************************************************
  def check_win(self):
    if len(self.enemy_list) == 0:
      self.view.set_status_text("The game is over");
      self.game_over = 1;
      pygame.mixer.music.load(os.path.join('data', 'music-attack.ogg'));
      #music is looping.
      pygame.mixer.music.play(-1);
      self.view.show_score();
      return 1;
    else:
      return 0;
 
